Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/AirflowInterfaceFactory.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/AirflowInterfaceFactory.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/AirflowInterfaceFactory.java	(revision 1396)
@@ -0,0 +1,31 @@
+package schedframe.resources.computing.profiles.energy.airthroughput;
+
+import schedframe.resources.StandardResourceType;
+import schedframe.resources.computing.ComputingResource;
+import schedframe.resources.computing.profiles.energy.airthroughput.ui.AirflowInterface;
+import schedframe.resources.computing.profiles.energy.airthroughput.ui.ComputingResourceAirflowInterface;
+import schedframe.resources.devices.PhysicalResource;
+import schedframe.resources.devices.DeviceAirflowInterface;
+import schedframe.resources.devices.coolemall.FanAirflowInterface;
+
+public class AirflowInterfaceFactory {
+	
+	public static AirflowInterface createAirflowInterface(PhysicalResource resource, AirflowProfile atp){
+		if(atp == null)
+			return null;
+		AirflowInterface airflowInterface = null;
+		if(resource.getType().getName().equals(StandardResourceType.CRAH.getName()))
+			airflowInterface = new DeviceAirflowInterface(resource, atp);
+		else if(resource.getType().getName().equals(StandardResourceType.Fan.getName()))
+			airflowInterface = new FanAirflowInterface(resource, atp);
+		else if(resource.getType().getName().equals(StandardResourceType.Inlet.getName()))
+			airflowInterface = new FanAirflowInterface(resource, atp);
+		else if(resource.getType().getName().equals(StandardResourceType.Outlet.getName()))
+			airflowInterface = new FanAirflowInterface(resource, atp);
+		else if(resource.getType().getName().equals(StandardResourceType.CoolingDevice.getName()))
+			airflowInterface = new DeviceAirflowInterface(resource, atp);
+		else
+			airflowInterface = new ComputingResourceAirflowInterface((ComputingResource)resource, atp);
+		return airflowInterface;
+	}
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/AirflowStateNameFactory.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/AirflowStateNameFactory.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/AirflowStateNameFactory.java	(revision 1396)
@@ -0,0 +1,16 @@
+package schedframe.resources.computing.profiles.energy.airthroughput;
+
+
+public class AirflowStateNameFactory {
+
+	public static AirflowStateName createAirflowStateName (String airflowStateName){
+		
+		if(airflowStateName.equals(StandardAirflowStateName.ON.getLabel()))
+			return StandardAirflowStateName.ON;
+		
+		else if(airflowStateName.equals(StandardAirflowStateName.OFF.getLabel()))
+			return StandardAirflowStateName.OFF;
+
+		else return new CustomAirflowStateName(airflowStateName);
+	}
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/ui/ComputingResourceAirflowInterface.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/ui/ComputingResourceAirflowInterface.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/ui/ComputingResourceAirflowInterface.java	(revision 1396)
@@ -0,0 +1,112 @@
+package schedframe.resources.computing.profiles.energy.airthroughput.ui;
+
+import java.util.ArrayList;
+import java.util.List;
+
+import org.joda.time.DateTimeUtils;
+
+import schedframe.Parameters;
+import schedframe.resources.computing.ComputingResource;
+import schedframe.resources.computing.profiles.energy.EnergyEvent;
+import schedframe.resources.computing.profiles.energy.EnergyEventType;
+import schedframe.resources.computing.profiles.energy.airthroughput.AirflowValue;
+import schedframe.resources.computing.profiles.energy.airthroughput.AirflowProfile;
+import schedframe.resources.computing.profiles.energy.airthroughput.AirflowState;
+import schedframe.resources.computing.profiles.energy.airthroughput.AirflowStateName;
+import schedframe.resources.computing.profiles.energy.airthroughput.StandardAirflowStateName;
+
+public class ComputingResourceAirflowInterface implements AirflowInterface{
+
+	protected AirflowStateName currentAirflowState;
+	protected AirflowProfile airflowProfile;
+	protected ComputingResource resource;
+	
+	public ComputingResourceAirflowInterface(ComputingResource resource, AirflowProfile airflowProfile){
+		this.resource = resource;
+		this.airflowProfile = airflowProfile;
+		this.currentAirflowState = StandardAirflowStateName.ON;
+	}
+	
+	public AirflowStateName getAirflowState() {
+		return currentAirflowState;
+	}
+
+	public boolean setAirflowState(AirflowStateName state) {
+		if(supportAirflowState(state)){
+			currentAirflowState = state;
+			
+			//TO DO - notifications should be called for all resources starting form the lowest layer
+			resource.handleEvent(new EnergyEvent(EnergyEventType.AIRFLOW_STATE_CHANGED, resource.getFullName()));
+			resource.handleEvent(new EnergyEvent(EnergyEventType.POWER_STATE_CHANGED, resource.getFullName()));
+			return true;
+		}
+		return false;
+	}
+
+	public boolean supportAirflowState(AirflowStateName state) {
+		for(AirflowState airflowState: airflowProfile.getAirflowStates()){
+			if(airflowState.getName().equals(state.getLabel())){
+				return true;
+			}
+		}
+		return false;
+	}
+
+	public List<AirflowState> getSupportedAirflowStates() {
+		List<AirflowState> airflowStates = new ArrayList<AirflowState>();
+		for(AirflowState airflowState: airflowProfile.getAirflowStates()){
+			airflowStates.add(airflowState);
+		}
+		return airflowStates;
+	}
+
+	public double getAirflow(AirflowStateName state) throws NoSuchFieldException {
+		double airflow = 0;
+		if(supportAirflowState(state)){
+			for(AirflowState airflowState: airflowProfile.getAirflowStates()){
+				if(airflowState.getName().equals(state.getLabel())){
+					airflow = airflowState.getValue();
+					break;
+				}
+			}
+		}
+		return airflow;
+	}
+
+	public double getPowerConsumption(AirflowStateName state) throws NoSuchFieldException {
+		double powerConsumption = 0;
+		if(supportAirflowState(state)){
+			for(AirflowState airflowState: airflowProfile.getAirflowStates()){
+				if(airflowState.getName().equals(state.getLabel())){
+					powerConsumption = airflowState.getPowerUsage();
+					break;
+				}
+			}
+		}
+		return powerConsumption;
+	}
+	
+	public AirflowValue getRecentAirflow() {
+		AirflowValue airflow = null;
+		int lastIdx = getAirflowHistory().size() - 1;
+		if(lastIdx >= 0)
+			airflow = getAirflowHistory().get(lastIdx);
+		else {	
+			try {
+				airflow = new AirflowValue(DateTimeUtils.currentTimeMillis(), getAirflow(currentAirflowState));
+			} catch (NoSuchFieldException e) {
+			}
+		}
+		return airflow;
+	}
+	
+	public List<AirflowValue> getAirflowHistory(){
+		return airflowProfile.getAirflowHistory();
+	}
+	
+	
+	public Parameters getParameters() {
+		return airflowProfile.getParameters();
+	}
+
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/ui/AirflowInterface.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/ui/AirflowInterface.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/ui/AirflowInterface.java	(revision 1396)
@@ -0,0 +1,31 @@
+package schedframe.resources.computing.profiles.energy.airthroughput.ui;
+
+import java.util.List;
+
+import schedframe.Parameters;
+import schedframe.resources.computing.profiles.energy.airthroughput.AirflowValue;
+import schedframe.resources.computing.profiles.energy.airthroughput.AirflowState;
+import schedframe.resources.computing.profiles.energy.airthroughput.AirflowStateName;
+
+public interface AirflowInterface {
+	
+	public AirflowStateName getAirflowState();
+	
+	public boolean setAirflowState(AirflowStateName airflowState);
+	
+	public boolean supportAirflowState(AirflowStateName powerState);
+	
+	public List<AirflowState> getSupportedAirflowStates();
+	
+	public double getAirflow(AirflowStateName state) throws NoSuchFieldException;
+	
+	public double getPowerConsumption(AirflowStateName state) throws NoSuchFieldException;
+	
+	public AirflowValue getRecentAirflow();
+	
+	List<AirflowValue> getAirflowHistory();
+	
+	public Parameters getParameters();
+	
+	
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/plugin/AirflowEstimationPlugin.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/plugin/AirflowEstimationPlugin.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/plugin/AirflowEstimationPlugin.java	(revision 1396)
@@ -0,0 +1,11 @@
+package schedframe.resources.computing.profiles.energy.airthroughput.plugin;
+
+import schedframe.Plugin;
+import schedframe.events.Event;
+import schedframe.resources.computing.ComputingResource;
+import schedframe.scheduling.manager.tasks.JobRegistry;
+
+public interface AirflowEstimationPlugin extends Plugin {
+	
+	public double estimateAirflow(Event event, JobRegistry jobRegistry, ComputingResource resource);
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/AirFlowValue.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/AirFlowValue.java	(revision 495)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/AirFlowValue.java	(revision 1396)
@@ -3,7 +3,7 @@
 import schedframe.resources.computing.profiles.energy.MeasurementHistory;
 
-public class AirFlowValue extends MeasurementHistory{
+public class AirflowValue extends MeasurementHistory{
 
-	public AirFlowValue(long timestamp, double value){
+	public AirflowValue(long timestamp, double value){
 		super(timestamp, value);
 	}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/AirflowValue.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/AirflowValue.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/AirflowValue.java	(revision 1396)
@@ -0,0 +1,11 @@
+package schedframe.resources.computing.profiles.energy.airthroughput;
+
+import schedframe.resources.computing.profiles.energy.MeasurementHistory;
+
+public class AirflowValue extends MeasurementHistory{
+
+	public AirflowValue(long timestamp, double value){
+		super(timestamp, value);
+	}
+	
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/CustomAirflowStateName.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/CustomAirflowStateName.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/CustomAirflowStateName.java	(revision 1396)
@@ -0,0 +1,17 @@
+package schedframe.resources.computing.profiles.energy.airthroughput;
+
+
+public class CustomAirflowStateName implements AirflowStateName{
+
+	protected String name;
+
+	public CustomAirflowStateName(String name) {
+		this.name = name;
+	}
+
+	public String getLabel() {
+		return name;
+	}
+
+
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/AirflowProfile.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/AirflowProfile.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/AirflowProfile.java	(revision 1396)
@@ -0,0 +1,65 @@
+package schedframe.resources.computing.profiles.energy.airthroughput;
+
+import java.util.ArrayList;
+import java.util.List;
+
+import org.joda.time.DateTimeUtils;
+
+import schedframe.Parameters;
+import schedframe.resources.computing.profiles.energy.airthroughput.plugin.AirflowEstimationPlugin;
+
+public class AirflowProfile {
+	
+	protected List<AirflowValue> airflowHistory;
+	
+	protected AirflowEstimationPlugin airflowEstimationPlugin;
+	protected List <AirflowState> airflowStates;
+	protected Parameters parameters;
+
+	public AirflowProfile(AirflowEstimationPlugin airflowEstimationPlugin, List<AirflowState> airflowStates) {
+		super();
+		this.airflowEstimationPlugin = airflowEstimationPlugin;
+		this.airflowStates = airflowStates;
+		this.airflowHistory = new ArrayList<AirflowValue>();
+	}
+
+	public List<AirflowState> getAirflowStates() {
+		return airflowStates;
+	}
+	
+	public void addToAirFlowHistory(double airflow) {
+
+		if (airflowHistory.size() == 0) {
+			AirflowValue usage = new AirflowValue(DateTimeUtils.currentTimeMillis(), airflow);
+			airflowHistory.add(usage);
+			return;
+		}
+
+		int lastIdx = airflowHistory.size() - 1;
+		double lastAirflow = airflowHistory.get(lastIdx).getValue();
+		if (lastAirflow != airflow) {
+			AirflowValue usage = airflowHistory.get(lastIdx);
+			long currentTime = DateTimeUtils.currentTimeMillis();
+			if (usage.getTimestamp() == currentTime) {
+				usage.setValue(airflow);
+				if(lastIdx > 0 && airflowHistory.get(lastIdx - 1).getValue() == airflow)
+					airflowHistory.remove(usage);
+			} else {
+				usage = new AirflowValue(DateTimeUtils.currentTimeMillis(), airflow);
+				airflowHistory.add(usage);
+			}
+		}
+	}
+
+	public List<AirflowValue> getAirflowHistory() {
+		return airflowHistory;
+	}
+	
+	public void init(Parameters params){
+		this.parameters = params;
+	}
+
+	public Parameters getParameters() {
+		return parameters;
+	}
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/AirflowState.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/AirflowState.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/AirflowState.java	(revision 1396)
@@ -0,0 +1,31 @@
+package schedframe.resources.computing.profiles.energy.airthroughput;
+
+import schedframe.Parameters;
+
+public class AirflowState {
+
+	protected AirflowStateName name;
+	protected double value;
+	protected double powerUsage;
+	
+	public AirflowState(AirflowStateName name, double value, double powerUsage) {
+		super();
+		this.name = name;
+		this.value = value;
+		this.powerUsage = powerUsage;
+	}
+	
+	public AirflowStateName getName() {
+		return name;
+	}
+	public double getValue() {
+		return value;
+	}
+	public double getPowerUsage() {
+		return powerUsage;
+	}
+	
+	public void init(Parameters parameters){
+		
+	}
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/AirflowStateName.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/AirflowStateName.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/AirflowStateName.java	(revision 1396)
@@ -0,0 +1,7 @@
+package schedframe.resources.computing.profiles.energy.airthroughput;
+
+public interface AirflowStateName {
+
+	public String getLabel();
+
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/EnergyExtension.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/EnergyExtension.java	(revision 1389)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/EnergyExtension.java	(revision 1396)
@@ -10,7 +10,7 @@
 import schedframe.resources.computing.extensions.ExtensionException;
 import schedframe.resources.computing.extensions.ExtensionType;
-import schedframe.resources.computing.profiles.energy.airthroughput.AirThroughputInterfaceFactory;
-import schedframe.resources.computing.profiles.energy.airthroughput.AirThroughputProfile;
-import schedframe.resources.computing.profiles.energy.airthroughput.ui.AirThroughputInterface;
+import schedframe.resources.computing.profiles.energy.airthroughput.AirflowInterfaceFactory;
+import schedframe.resources.computing.profiles.energy.airthroughput.AirflowProfile;
+import schedframe.resources.computing.profiles.energy.airthroughput.ui.AirflowInterface;
 import schedframe.resources.computing.profiles.energy.power.PowerInterfaceFactory;
 import schedframe.resources.computing.profiles.energy.power.PowerProfile;
@@ -30,6 +30,6 @@
 	protected PowerProfile powerProfile;
 	
-	protected AirThroughputInterface airFlowInterface;
-	protected AirThroughputProfile airFlowProfile;
+	protected AirflowInterface airflowInterface;
+	protected AirflowProfile airflowProfile;
 	
 	protected ThermalInterface thermalInterface;
@@ -74,6 +74,6 @@
 		protected PowerProfile powerProfile;
 		
-		protected AirThroughputInterface airFlowInterface;
-		protected AirThroughputProfile airFlowProfile;
+		protected AirflowInterface airflowInterface;
+		protected AirflowProfile airflowProfile;
 		
 		protected ThermalInterface thermalInterface;
@@ -84,5 +84,5 @@
 		public Builder powerProfile(PowerProfile pp){this.powerProfile = pp; this.powerInterface = PowerInterfaceFactory.createPowerInterface(resource, powerProfile); return this; }
 
-        public Builder airFlowProfile(AirThroughputProfile atp){this.airFlowProfile = atp; this.airFlowInterface = AirThroughputInterfaceFactory.createAirThroughputInterface(resource, airFlowProfile); return this; }
+        public Builder airflowProfile(AirflowProfile atp){this.airflowProfile = atp; this.airflowInterface = AirflowInterfaceFactory.createAirflowInterface(resource, airflowProfile); return this; }
 
         public Builder thermalProfile(ThermalProfile tp){this.thermalProfile = tp; this.thermalInterface = ThermalInterfaceFactory.createThermalInterface(resource, thermalProfile); return this; }
@@ -98,6 +98,6 @@
 		this.powerProfile = builder.powerProfile;
 		
-		this.airFlowInterface = builder.airFlowInterface ;
-		this.airFlowProfile = builder.airFlowProfile;
+		this.airflowInterface = builder.airflowInterface ;
+		this.airflowProfile = builder.airflowProfile;
 		
 		this.thermalInterface = builder.thermalInterface;
@@ -163,6 +163,6 @@
 				
 			case AIRFLOW_STATE_CHANGED:
-				double airFlow = powerProfile.getEnergyEstimationPlugin().estimateAirThroughput(enEvent, new JobRegistryImpl(resource.getFullName()), resource);
-				airFlowProfile.addToAirFlowHistory(airFlow);
+				double airflow = powerProfile.getEnergyEstimationPlugin().estimateAirflow(enEvent, new JobRegistryImpl(resource.getFullName()), resource);
+				airflowProfile.addToAirFlowHistory(airflow);
 				break;
 				
@@ -204,10 +204,10 @@
 	}
 
-	public AirThroughputInterface getAirThroughputInterface() {
-		return airFlowInterface;
-	}
-
-	public AirThroughputProfile getAirFlowProfile() {
-		return airFlowProfile;
+	public AirflowInterface getAirflowInterface() {
+		return airflowInterface;
+	}
+
+	public AirflowProfile getAirFlowProfile() {
+		return airflowProfile;
 	}
 	
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/CustomPowerStateName.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/CustomPowerStateName.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/CustomPowerStateName.java	(revision 1396)
@@ -0,0 +1,16 @@
+package schedframe.resources.computing.profiles.energy.power;
+
+public class CustomPowerStateName implements PowerStateName {
+
+	protected String name;
+
+	public CustomPowerStateName(String name) {
+		this.name = name;
+	}
+
+	public String getLabel() {
+		return name;
+	}
+
+
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/ui/ComputingResourcePowerInterface.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/ui/ComputingResourcePowerInterface.java	(revision 1374)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/ui/ComputingResourcePowerInterface.java	(revision 1396)
@@ -74,5 +74,5 @@
 	public boolean supportPowerState(PowerStateName state) {
 		for(PowerState powerState: powerProfile.getSupportedPowerStates()){
-			if(powerState.getName().getName().equals(state.getName())){
+			if(powerState.getName().getLabel().equals(state.getLabel())){
 				return true;
 			}
@@ -86,5 +86,5 @@
 		if(supportPowerState(state)){
 			for(PowerState powerState: powerProfile.getSupportedPowerStates()){
-				if(powerState.getName().getName().equals(state.getName())){
+				if(powerState.getName().getLabel().equals(state.getLabel())){
 					powerConsumption = powerState.getPowerUsage();
 					break;
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/PowerStateName.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/PowerStateName.java	(revision 477)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/PowerStateName.java	(revision 1396)
@@ -3,5 +3,5 @@
 public interface PowerStateName {
 	
-	public String getName();
+	public String getLabel();
 
 }
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/plugin/EnergyEstimationPlugin.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/plugin/EnergyEstimationPlugin.java	(revision 1207)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/plugin/EnergyEstimationPlugin.java	(revision 1396)
@@ -10,5 +10,5 @@
 	public double estimatePowerConsumption(EnergyEvent event, JobRegistry jobRegistry, PhysicalResource resource);
 
-	public double estimateAirThroughput(EnergyEvent event, JobRegistry jobRegistry, PhysicalResource resource);
+	public double estimateAirflow(EnergyEvent event, JobRegistry jobRegistry, PhysicalResource resource);
 
 	public double estimateTemperature(EnergyEvent event, JobRegistry jobRegistry, PhysicalResource resource);
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/StandardPowerStateName.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/StandardPowerStateName.java	(revision 477)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/StandardPowerStateName.java	(revision 1396)
@@ -10,5 +10,5 @@
 	HIBERNATE;
 
-	public String getName() {
+	public String getLabel() {
 		return toString();
 	}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/PowerStateNameFactory.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/PowerStateNameFactory.java	(revision 477)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/PowerStateNameFactory.java	(revision 1396)
@@ -6,20 +6,20 @@
 	public static PowerStateName createPowerStateName (String powerStateName){
 		
-		if(powerStateName.equals(StandardPowerStateName.ON.getName()))
+		if(powerStateName.equals(StandardPowerStateName.ON.getLabel()))
 			return StandardPowerStateName.ON;
 		
-		else if(powerStateName.equals(StandardPowerStateName.OFF.getName()))
+		else if(powerStateName.equals(StandardPowerStateName.OFF.getLabel()))
 			return StandardPowerStateName.OFF;
 		
-		else if(powerStateName.equals(StandardPowerStateName.HIBERNATE.getName()))
+		else if(powerStateName.equals(StandardPowerStateName.HIBERNATE.getLabel()))
 			return StandardPowerStateName.HIBERNATE;
 		
-		else if(powerStateName.equals(StandardPowerStateName.SLEEP.getName()))
+		else if(powerStateName.equals(StandardPowerStateName.SLEEP.getLabel()))
 			return StandardPowerStateName.SLEEP;
 		
-		else if(powerStateName.equals(StandardPowerStateName.SUSPEND.getName()))
+		else if(powerStateName.equals(StandardPowerStateName.SUSPEND.getLabel()))
 			return StandardPowerStateName.SUSPEND;
 		
-		else return new UserPowerStateName(powerStateName);
+		else return new CustomPowerStateName(powerStateName);
 	}
 }
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/ComputingResource.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/ComputingResource.java	(revision 1392)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/ComputingResource.java	(revision 1396)
@@ -57,5 +57,5 @@
 		initCharacteristics(resDesc);
 		accept(new LoadExtension(resDesc.getLoadProfile(), this));
-		accept(new EnergyExtension.Builder().resource(this).powerProfile(resDesc.getPowerProfile()).airFlowProfile(resDesc.getAirThroughputProfile()).thermalProfile(resDesc.getThermalProfile()).build());	
+		accept(new EnergyExtension.Builder().resource(this).powerProfile(resDesc.getPowerProfile()).airflowProfile(resDesc.getAirflowProfile()).thermalProfile(resDesc.getThermalProfile()).build());	
 	}
 
Index: DCWoRMS/branches/coolemall/src/schedframe/SimulatedEnvironment.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/SimulatedEnvironment.java	(revision 1207)
+++ DCWoRMS/branches/coolemall/src/schedframe/SimulatedEnvironment.java	(revision 1396)
@@ -11,5 +11,5 @@
 
 import schedframe.exceptions.ResourceException;
-import schedframe.resources.ResourceHistoryChanges;
+import schedframe.resources.ResourceHistoryItem;
 import schedframe.resources.computing.ComputingResource;
 import schedframe.scheduling.Scheduler;
@@ -21,5 +21,5 @@
 	protected List<Initializable> toInit;
 	protected Set<String> compResLayers;
-	protected static List<ResourceHistoryChanges> compResHistory = new ArrayList<ResourceHistoryChanges>();
+	protected static List<ResourceHistoryItem> compResHistory = new ArrayList<ResourceHistoryItem>();
 	
 	public SimulatedEnvironment(Scheduler logicalStructure, List<ComputingResource> compResources){
@@ -156,9 +156,9 @@
 
 	public static void traceResource(long timestamp, String resourceName, String operation, String paramter){
-		ResourceHistoryChanges rhc = new ResourceHistoryChanges(timestamp, resourceName, operation, paramter);
+		ResourceHistoryItem rhc = new ResourceHistoryItem(timestamp, resourceName, operation, paramter);
 		compResHistory.add(rhc);
 	}
 
-	public static List<ResourceHistoryChanges> getCompResHistory() {
+	public static List<ResourceHistoryItem> getCompResHistory() {
 		return compResHistory;
 	}
